#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,20,4);

String rx;
byte id_pot=0;
int srv[4]={90,90,90,90};
int joy[4]={0,0,0,0};

void setup() {
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  while (Serial.read()!=10);
}

void loop() {
  while (!Serial.available());
  delay(100);
  while (Serial.available())
  {
    char c=Serial.read();
    if ((c>='0') && (c<='9'))
      rx+=c;
    else
    if ((c=='-') && (rx==""))
      rx="-";
    else
    {
      if ((rx!="") && (id_pot<4))
      {
        joy[id_pot++]=rx.toInt();
        rx="";
      }
      if (c==10)
      {
        id_pot=0;
        rx="";
      }
    }
  }
  for (int i=0; i<4; i++)
  {
    srv[i]+=joy[i];
    if (srv[i]<0) srv[i]=0;
    if (srv[i]>180) srv[i]=180;
    char s[20];
    sprintf(s,"A%d %4d %4d",i,joy[i],srv[i]);
    lcd.setCursor(3,i);
    lcd.print(s);
  }
}
